import time

import structlog
from flask import request

slogger = structlog.get_logger(__name__)


def before_request_log_setup():
    slogger.new()
    request.start = time.monotonic()


def after_request_log_teardown(response):
    duration = time.monotonic() - request.start
    slogger.debug(
        "request.finished",
        path=request.path,
        rule=request.url_rule.rule if request.url_rule else None,  # None for 404
        method=request.method,
        status=response.status_code,
        duration=round(duration * 1000, 3),
    )
    return response
